#include<bits/stdc++.h>
using namespace std;
#define VI vector<int>
#define PII pair<int, int>
#define VPI vector<PII>
#define mp make_pair
#define eb emplace_back
#define pb push_back
#define st first
#define nd second
#define endl '\n'
#define debug(x) cerr << #x << " " << x << endl;
#define ll long long

#define int ll

const int N = 500 + 7;
const int M = 26;
const int mod = 1e9 + 7;

int n, q;

int trie[N][M];
int suflink[N];
int closed[N];

int root = 1;
int cou = 1;

int dp[N][N];
int res[N];

void add(string s){
	int cur = root;
	
	for(auto it:s){
		if (trie[cur][it - 'a'] == 0){
			trie[cur][it - 'a'] = ++cou;
		}
		
		cur = trie[cur][it - 'a'];
	}
	
	closed[cur] = 1;
}

void aho(){
	queue <int> q;
	
	suflink[root] = root;

	for(int i = 0; i < M; i++){
		if (trie[root][i] != 0){
			suflink[trie[root][i]] = root;
			q.push(trie[root][i]);
		}
	}
	
	while(!q.empty()){
		auto it = q.front();
		q.pop();
		
		for(int i = 0; i < M; i++){
			if (trie[it][i] != 0){
				auto tmp = suflink[it];
				
				while(tmp != root && trie[tmp][i] == 0){
					tmp = suflink[tmp];
				}
				
				if (trie[tmp][i] != 0){
					tmp = trie[tmp][i];
				}
				
				suflink[trie[it][i]] = tmp;
				
				q.push(trie[it][i]);
			}
		}
	}
}

int curLicze;

void dfs(int v){	
	for(int i = 0; i < M; i++){
		if (trie[v][i] == 0){
			auto tmp = suflink[v];
			
			while(tmp != root && trie[tmp][i] == 0){
				tmp = suflink[tmp];
			}
			
			if (trie[tmp][i] != 0){
				tmp = trie[tmp][i];
			}
			
			dp[curLicze][tmp] += dp[curLicze - 1][v];
			dp[curLicze][tmp] %= mod;
		}else{
			dp[curLicze][trie[v][i]] += dp[curLicze - 1][v];
			dp[curLicze][trie[v][i]] %= mod;
		}
	}
	
	for(int i = 0; i < M; i++){
		if (trie[v][i] != 0 && closed[trie[v][i]] == 0){
			dfs(trie[v][i]);
		}
	}
}

void licz(int ilePolicz){
	dp[0][root] = 1;
	
	for(int i = 1; i <= ilePolicz; i++){
		curLicze = i;
		dfs(root);
		
		for(int j = 1; j <= cou; j++){
			if (closed[j] == 0){
				res[i] += dp[i][j];
				res[i] %= mod;
			}
		}
	}
	
	return;
}

void add_self(int& a, int b) { a += b; if (a >= mod) a -= mod;}
void sub_self(int& a, int b) { a -= b; if (a < 0) a += mod;}
int mul(int a, int b) { return (ll) a * b % mod; }
int my_pow(int a, int b) {
	int r = 1;
	while(b) {
		if (b%2) r = mul(r, a);
		a = mul(a, a);
		b /= 2;
	}
	return r;
}

int my_inv(int a) {return my_pow(a, mod - 2); }

struct Massey {
	vector<int> start, coef;
	vector<vector<int>> powers;
	int memo_inv;
	int L;
	
	Massey(vector<int>in){
		L = 0;
		const int N = in.size();
		vector<int>C{1}, B{1};
		for(int n = 0; n < N; ++n){
			assert(0 <= in[n] && in[n] < mod);
			B.insert(B.begin(), 0);
			int d = 0;
			for(int i = 0; i <= L; i++){
				add_self(d, mul(C[i], in[n-i]));
			}
			
			if (d == 0) continue;
			
			vector<int>T = C;
			C.resize(max(B.size(), C.size()));
			for(int i = 0; i < (int) B.size(); ++i){
				sub_self(C[i], mul(d, B[i]));
			}
			
			if (2 * L <= n){
				L = n + 1 - L;
				B = T;
				d = my_inv(d);
				for(int & x : B) x = mul(x, d);
			}
		}
		
		assert(2 * L <= N - 2);
	
		for(int i = 1; i < (int) C.size(); i++){
			coef.push_back((mod - C[i]) % mod);
		}
		assert((int) coef.size() == L);
		for(int i = 0; i < L; i++){
			start.push_back(in[i]);
		}
		
		while(!coef.empty() && !coef.back()) {coef.pop_back(); L--;}
		if (!coef.empty()) memo_inv = my_inv(coef.back());
		powers.push_back(coef);
	}

	vector<int> mul_cut(vector<int> a, vector<int> b){
		vector<int>r(2*L - 1);
		for(int i = 0; i < L; i++){
			for(int j = 0; j < L; j++){
				add_self(r[i+j], mul(a[i], b[j]));
			}
		}
		
		while((int) r.size() > L){
			int value = mul(r.back(), memo_inv);
			const int X = r.size();
			add_self(r[X-L-1], value);
			for(int i = 0; i < L; i++){
				sub_self(r[X - L + i], mul(value, coef[i]));
			}
			assert(r.back()==0);
			r.pop_back();
		}
		
		return r;
	}
	
	int get(ll k){
		if (k < (int) start.size()) return start[k];
		if (L == 0) return 0;
		k -= start.size();
		vector<int>vec = coef;
		
		for(int i = 0; (1LL << i) <= k; i++){
			if (i == (int) powers.size())
				powers.push_back(mul_cut(powers.back(), powers.back()));
			if (k & (1LL < i))
				vec = mul_cut(vec, powers[i]);
		}
		
		int total = 0;
		for(int i = 0; i < L; i++){
			add_self(total, mul(vec[i], start[(int)start.size() - 1 - i]));
		}
		
		return total;
	}
};

void solve(){
	cin >> n >> q;
	
	for(int i = 1; i <= q; i++){
		int x;
		cin >> x;
		string s;
		cin >> s;
		add(s);
	}
	
	aho();
	licz(300);
	
	VI tmp;
	
	for(int i = 0; i <= 300; i++){
		tmp.pb(res[i]);
		//cout << res[i] << endl;
	}
	
	Massey masej = Massey(tmp);
	cout << res[n] << endl;
	cout << masej.get(n + 4) << endl;
}

int32_t main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int test = 1;
	
	while(test--){
		solve();
	}
	
	return 0;
}

