#include<bits/stdc++.h>
using namespace std;
#define VI vector<int>
#define PII pair<int, int>
#define VPI vector<PII>
#define mp make_pair
#define eb emplace_back
#define pb push_back
#define st first
#define nd second
#define endl '\n'
#define debug(x) cerr << #x << " " << x << endl;
#define ll long long

#define int ll

const int N = 100 + 7;
const int M = 26;
const int mod = 1e9 + 7;

int n, q;

int trie[N][M];
int suflink[N];
int closed[N];

int root = 1;
int cou = 1;

void add(string s){
	int cur = root;
	
	for(auto it:s){
		if (trie[cur][it - 'a'] == 0){
			trie[cur][it - 'a'] = ++cou;
		}
		
		cur = trie[cur][it - 'a'];
	}
	
	closed[cur] = 1;
}

void aho(){
	queue <int> q;
	
	suflink[root] = root;

	for(int i = 0; i < M; i++){
		if (trie[root][i] != 0){
			suflink[trie[root][i]] = root;
			q.push(trie[root][i]);
		}
	}
	
	while(!q.empty()){
		auto it = q.front();
		q.pop();
		
		for(int i = 0; i < M; i++){
			if (trie[it][i] != 0){
				auto tmp = suflink[it];
				
				while(tmp != root && trie[tmp][i] == 0){
					tmp = suflink[tmp];
				}
				
				if (trie[tmp][i] != 0){
					tmp = trie[tmp][i];
				}
				
				suflink[trie[it][i]] = tmp;
				
				closed[trie[it][i]] = max(closed[trie[it][i]], closed[suflink[trie[it][i]]]);
				closed[trie[it][i]] = max(closed[trie[it][i]], closed[it]);
				q.push(trie[it][i]);
			}
		}
	}
}

struct mat{
	int t[N][N];
};

mat myMat;

void dfs(int v){	
	for(int i = 0; i < M; i++){
		if (trie[v][i] == 0){
			auto tmp = suflink[v];
			
			while(tmp != root && trie[tmp][i] == 0){
				tmp = suflink[tmp];
			}
			
			if (trie[tmp][i] != 0){
				tmp = trie[tmp][i];
			}
			
			if (closed[tmp] == 0)
				myMat.t[tmp][v] += 1;
		}else{
			if (closed[trie[v][i]] == 0)
				myMat.t[trie[v][i]][v] += 1;
		}
	}
	
	for(int i = 0; i < M; i++){
		if (trie[v][i] != 0 && closed[trie[v][i]] == 0){
			dfs(trie[v][i]);
		}
	}
}

mat mul(mat a, mat b){
	mat c;
	for(int i = 0; i < N; i++){
		for(int j = 0; j < N; j++)
			c.t[i][j] = 0;
	}
	
	for(int i = 0; i < N; i++)
		for(int j = 0; j < N; j++)
			for(int k = 0; k < N; k++)
				c.t[i][j] = (c.t[i][j] + a.t[i][k] * b.t[k][j]) % mod;
				
	return c;
}

mat my_pow(mat a, int b) {
	mat r;
	
	for(int i = 0; i < N; i++){
		for(int j = 0; j < N; j++)
			r.t[i][j] = 0;
	}
	
	for(int i = 0; i < N; i++)
		r.t[i][i] = 1;
	
	while(b) {
		if (b%2) r = mul(r, a);
		a = mul(a, a);
		b /= 2;
	}
	
	return r;
}

void solve(){
	cin >> n >> q;
	
	for(int i = 1; i <= q; i++){
		int x;
		cin >> x;
		string s;
		cin >> s;
		add(s);
	}
	
	aho();

	for(int i = 0; i < N; i++)
		for(int j = 0 ;j < N; j++)
			myMat.t[i][j] = 0;
			
			
	dfs(root);

	mat wyn = my_pow(myMat, n);
	
	int res = 0;
	
	for(int i = 1; i <= cou; i++){
		if (closed[i] == 0){
			res += wyn.t[i][1];
			res %= mod;
		}
	}
	
	cout << res;

}

int32_t main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int test = 1;
	
	while(test--){
		solve();
	}
	
	return 0;
}

